"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const build_angular_1 = require("@angular-devkit/build-angular");
const build_plugin_1 = require("../build-plugin");
const operators_1 = require("rxjs/operators");
class PluginBrowserBuilder extends build_angular_1.BrowserBuilder {
    run(builderConfig) {
        build_plugin_1.BuildPlugin.loadPlugin(this.context.workspace.root, builderConfig.options);
        build_plugin_1.BuildPlugin.runHook(build_plugin_1.BuildPlugin.PRE_HOOK, builderConfig);
        return super.run(builderConfig).pipe(operators_1.tap(() => build_plugin_1.BuildPlugin.runHook(build_plugin_1.BuildPlugin.POST_HOOK, builderConfig)));
    }
    buildWebpackConfig(root, projectRoot, host, options) {
        const webpackConfig = super.buildWebpackConfig(root, projectRoot, host, options);
        return build_plugin_1.BuildPlugin.runHook(build_plugin_1.BuildPlugin.CONFIG_HOOK, webpackConfig) || webpackConfig;
    }
}
exports.PluginBrowserBuilder = PluginBrowserBuilder;
exports.default = PluginBrowserBuilder;
//# sourceMappingURL=index.js.map