"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const build_angular_1 = require("@angular-devkit/build-angular");
const build_plugin_1 = require("../build-plugin");
const browser_1 = require("../browser");
const operators_1 = require("rxjs/operators");
class PluginDevServerBuilder extends build_angular_1.DevServerBuilder {
    run(builderConfig) {
        const architect = this.context.architect;
        const [project, target, configuration] = builderConfig.options.browserTarget.split(':');
        const browserTargetSpec = { project, target, configuration };
        const browserBuilderConfig = architect.getBuilderConfiguration(browserTargetSpec);
        builderConfig.options.plugin = builderConfig.options.plugin || browserBuilderConfig.options.plugin;
        build_plugin_1.BuildPlugin.loadPlugin(this.context.workspace.root, builderConfig.options);
        build_plugin_1.BuildPlugin.runHook(build_plugin_1.BuildPlugin.PRE_HOOK, builderConfig);
        return super.run(builderConfig).pipe(operators_1.tap(() => build_plugin_1.BuildPlugin.runHook(build_plugin_1.BuildPlugin.POST_HOOK, builderConfig)));
    }
    buildWebpackConfig(root, projectRoot, host, options) {
        const browserBuilder = new browser_1.PluginBrowserBuilder(this.context);
        return browserBuilder.buildWebpackConfig(root, projectRoot, host, options);
    }
}
exports.PluginDevServerBuilder = PluginDevServerBuilder;
exports.default = PluginDevServerBuilder;
//# sourceMappingURL=index.js.map